/*----------------------------------------------------------------------------
 * Name:    ROSA_external.h
 * Purpose:    (-) 
 *					Russian Event OS			(ROSA-e)
 * Note(s):      
 *----------------------------------------------------------------------------
 *    .   
 *        .    
 *    )))   " ".
 *
 * This software is supplied "AS IS" without warranties of any kind.
 *
 * Copyright (c) 2016 RUAL
 *----------------------------------------------------------------------------*/
#ifndef __ROSA_EXTERNAL_H
#define __ROSA_EXTERNAL_H

#ifdef __cplusplus
 extern "C" {
#endif 
 
#include "ROSA_port.h" 		/*   */

extern const char ROSA_Name_R[];
extern const char ROSA_Name_E[];
extern const char ROSA_Realise_R[];
extern const char ROSA_Realise_E[];
extern const char ROSA_Port_R[];
extern const char ROSA_Port_E[];

typedef enum {
	EVENT_NULL = 0,
	EVENT_STOP,
	EVENT_WAIT,	
	EVENT_READY,
	EVENT_RUN,	
	EVENT_BLOCK,
	EVENT_BLOCK_WAIT
} Event_Stat_TypeDef;  /*   */

typedef void(*Event_TypeDef)(void);										/*      */
typedef unsigned char Event_Number_TypeDef;						/*      */
typedef Event_Number_TypeDef Event_Priorety_TypeDef;	/*      */

/*    */
extern void ROSA_Init(IRQ_Priority_TypeDef p);

/*    */
extern void ROSA_CallEvent(Event_Number_TypeDef n);

/*   */
extern Event_Stat_TypeDef ROSA_GetStatEvent(Event_Number_TypeDef n);

/*   */
extern Event_Number_TypeDef _CountWait_Event;
#define ROSA_GetWaitingEvent() _CountWait_Event

/*    */
extern void ROSA_BlockEvent(Event_Number_TypeDef n);
extern void ROSA_UnBlockEvent(Event_Number_TypeDef n);

/*      */
extern Event_Number_TypeDef ROSA_GetFailCount(Event_Number_TypeDef n);
extern void ROSA_ResetFailCount(Event_Number_TypeDef n);

/*    */
#ifndef ROSA_ConstPriority
extern void SetEventPriority(Event_Number_TypeDef n, Event_Priorety_TypeDef p);
#else 
#define SetEventPriority(n,p)
#endif
extern Event_Priorety_TypeDef GetEventPriority(Event_Number_TypeDef n);

#define Max_EventNumber	0xff
extern const Event_TypeDef _Event_List[]; 	/*    */

/*      */
//#define Event_List(ptr)	const Event_TypeDef _Event_List[] = {ptr};
//const unsigned char Event_Count (sizeof(_Event_List)/sizeof(_Event_List[0]));

//extern const unsigned char Event_Count; /*     */ 


#ifdef __cplusplus
}
#endif

#endif /* __ROSA_EXTERNAL_H */

