/*----------------------------------------------------------------------------
 * Name:    ROSA_port.h
 * Purpose:    (-) 
 *					Russian Event OS			(ROSA-e)
 * Note(s):        STM32
 *----------------------------------------------------------------------------
 *    .   
 *        .    
 *    )))   " ".
 *
 * This software is supplied "AS IS" without warranties of any kind.
 *
 * Copyright (c) 2016 RUAL
 *----------------------------------------------------------------------------*/
 
#include "ROSA_config.h"

#ifndef __ROSA_PORT_H
#define __ROSA_PORT_H

#ifdef __cplusplus
 extern "C" {
#endif 
	 
typedef unsigned int ROSA_BASE_TypeDef;
typedef unsigned int IRQ_Priority_TypeDef;	 

#define ROSA_InterruptDisable() __asm ("CPSID	I")
#define ROSA_InterruptEnable()	__asm ("CPSIE	I")
	 
#define ROSA_AtomReadByte(s)		__ldrexb(s)
#define ROSA_AtomWriteByte(s,d)	__strexb(s,d)	 
	 
#define ROSA_InitInt(p) NVIC_SetPriority(SVCall_IRQn, p)

/*    - 
	     */
extern unsigned char ROSA_CS_Flag;
extern void _PendSVC(void);						/*   SVC */
#define ROSA_Critical_Section_Begin() ROSA_CS_Flag = 1
#define ROSA_Critical_Section_End() 	{ROSA_CS_Flag = 0;\
																			_PendSVC();}
	 
#ifdef __cplusplus
}
#endif

#endif /* __ROSA_PORT_H */
